# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::StreamAnalytics::Mgmt::V2016_03_01
  module Models
    #
    # An output object, containing all information associated with the named
    # output. All outputs are contained under a streaming job.
    #
    class Output < SubResource

      include MsRestAzure

      # @return [OutputDataSource] Describes the data source that output will
      # be written to. Required on PUT (CreateOrReplace) requests.
      attr_accessor :datasource

      # @return [Serialization] Describes how data from an input is serialized
      # or how data is serialized when written to an output. Required on PUT
      # (CreateOrReplace) requests.
      attr_accessor :serialization

      # @return [Diagnostics] Describes conditions applicable to the Input,
      # Output, or the job overall, that warrant customer attention.
      attr_accessor :diagnostics

      # @return [String] The current entity tag for the output. This is an
      # opaque string. You can use it to detect whether the resource has
      # changed between requests. You can also use it in the If-Match or
      # If-None-Match headers for write operations for optimistic concurrency.
      attr_accessor :etag


      #
      # Mapper for Output class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'Output',
          type: {
            name: 'Composite',
            class_name: 'Output',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              datasource: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.datasource',
                type: {
                  name: 'Composite',
                  polymorphic_discriminator: 'type',
                  uber_parent: 'OutputDataSource',
                  class_name: 'OutputDataSource'
                }
              },
              serialization: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.serialization',
                type: {
                  name: 'Composite',
                  polymorphic_discriminator: 'type',
                  uber_parent: 'Serialization',
                  class_name: 'Serialization'
                }
              },
              diagnostics: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.diagnostics',
                type: {
                  name: 'Composite',
                  class_name: 'Diagnostics'
                }
              },
              etag: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.etag',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
