# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::StreamAnalytics::Mgmt::V2016_03_01
  module Models
    #
    # Describes a Power BI output data source.
    #
    class PowerBIOutputDataSource < OutputDataSource

      include MsRestAzure


      def initialize
        @type = "PowerBI"
      end

      attr_accessor :type

      # @return [String] A refresh token that can be used to obtain a valid
      # access token that can then be used to authenticate with the data
      # source. A valid refresh token is currently only obtainable via the
      # Azure Portal. It is recommended to put a dummy string value here when
      # creating the data source and then going to the Azure Portal to
      # authenticate the data source which will update this property with a
      # valid refresh token. Required on PUT (CreateOrReplace) requests.
      attr_accessor :refresh_token

      # @return [String] The user principal name (UPN) of the user that was
      # used to obtain the refresh token. Use this property to help remember
      # which user was used to obtain the refresh token.
      attr_accessor :token_user_principal_name

      # @return [String] The user display name of the user that was used to
      # obtain the refresh token. Use this property to help remember which user
      # was used to obtain the refresh token.
      attr_accessor :token_user_display_name

      # @return [String] The name of the Power BI dataset. Required on PUT
      # (CreateOrReplace) requests.
      attr_accessor :dataset

      # @return [String] The name of the Power BI table under the specified
      # dataset. Required on PUT (CreateOrReplace) requests.
      attr_accessor :table

      # @return [String] The ID of the Power BI group.
      attr_accessor :group_id

      # @return [String] The name of the Power BI group. Use this property to
      # help remember which specific Power BI group id was used.
      attr_accessor :group_name


      #
      # Mapper for PowerBIOutputDataSource class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'PowerBI',
          type: {
            name: 'Composite',
            class_name: 'PowerBIOutputDataSource',
            model_properties: {
              type: {
                client_side_validation: true,
                required: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              refresh_token: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.refreshToken',
                type: {
                  name: 'String'
                }
              },
              token_user_principal_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.tokenUserPrincipalName',
                type: {
                  name: 'String'
                }
              },
              token_user_display_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.tokenUserDisplayName',
                type: {
                  name: 'String'
                }
              },
              dataset: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.dataset',
                type: {
                  name: 'String'
                }
              },
              table: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.table',
                type: {
                  name: 'String'
                }
              },
              group_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.groupId',
                type: {
                  name: 'String'
                }
              },
              group_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.groupName',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
